/* ***** BEGIN LICENSE BLOCK *****
 *   Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is ABV Checker.
 *
 * The Initial Developer of the Original Code is
 * Krasimir Stefanov.
 * Portions created by the Initial Developer are Copyright (C) 2009
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 * 
 * ***** END LICENSE BLOCK ***** */
var abvchecktimer = 0;


var abvchecker = {
	prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.abvchecker."),
	timer: false, 
	onLoad: function() {
		// initialization code
		this.initialized = true;
		this.strings = document.getElementById("abvchecker-strings");
		
		
		const XUL_NS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";	
		var prefs = Components.classes["@mozilla.org/preferences-service;1"]
										 .getService(Components.interfaces.nsIPrefService)
										 .getBranch("extensions.abvchecker.accounts.");
		var count = new Object;
		var childs = prefs.getChildList("",count);
		for (var i in childs){
			// alert(childs[i]);
			// var accounts = document.getElementById('accounts');
			// accounts.appendItem( childs[i], prefs.getCharPref(childs[i]) );


			var menuitem = document.createElementNS(XUL_NS, "menuitem"); 
			menuitem.setAttribute('id',childs[i]+'_menuitem');
			// menuitem.setAttribute('onclick',checker.id+'.open(accounts.data['+i+']["params"],'+i+')');
			document.getElementById('abvchecker-menu').appendChild(menuitem);
			
			var image = document.createElementNS(XUL_NS, "image"); 
			image.setAttribute('id',childs[i]+'_icon');
			image.setAttribute('src','chrome://abvchecker/content/email-0.png'); 
			// image.setAttribute('onclick',checker.id+'.check(accounts.data['+i+']["params"],'+i+')');
			menuitem.appendChild(image);
			
            
			var label = document.createElementNS(XUL_NS, "label"); 
			label.setAttribute('id',childs[i]+'_label');
			label.setAttribute('style','cursor: pointer;'); 
			label.setAttribute('value',childs[i]);
			menuitem.appendChild(label);
			
			var spacer = document.createElementNS(XUL_NS, "spacer"); 
			spacer.setAttribute('flex','1');
			menuitem.appendChild(spacer);
			
			var label = document.createElementNS(XUL_NS, "label"); 
			label.setAttribute('id',childs[i]+'_count_label');
			label.setAttribute('style','cursor: pointer;'); 
			label.setAttribute('value',0);
			menuitem.appendChild(label);
			
		}
		
		this.checkForNewMail();
	},
	
	onMenuItemCommand: function(e) {
		var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
			.getService(Components.interfaces.nsIPromptService);
		promptService.alert(window, this.strings.getString("helloMessageTitle"),
			this.strings.getString("helloMessage"));
	},
	
	openABV: function(){
		return;
		
		
		var dataString = "password="+this.prefs.getCharPref('password')+"&username="+this.prefs.getCharPref('username')+"&host="+this.prefs.getCharPref('host')+"&hostname="+this.prefs.getCharPref('hostname');

		// POST method requests must wrap the encoded text in a MIME
		// stream
		const Cc = Components.classes;
		const Ci = Components.interfaces;
		var stringStream = Cc["@mozilla.org/io/string-input-stream;1"].
						   createInstance(Ci.nsIStringInputStream);
		if ("data" in stringStream) // Gecko 1.9 or newer
		  stringStream.data = dataString;
		else // 1.8 or older
		  stringStream.setData(dataString, dataString.length);

		var postData = Cc["@mozilla.org/network/mime-input-stream;1"].
					   createInstance(Ci.nsIMIMEInputStream);
		postData.addHeader("Content-Type", "application/x-www-form-urlencoded");
		postData.addContentLength = true;
		postData.setData(stringStream);


		var tab = getBrowser().addTab( 'https://passport.abv.bg/servlet/passportlogin', makeURI('http://www.abv.bg/'), 'UTF-8',postData);		
	},
	
	checkForNewMail: function(){
		// return;
		// clearTimeout(abvchecktimer);
		
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.abvchecker.accounts.");
		var count = new Object;
		var childs = prefs.getChildList("",count);
		
		// document.getElementById('abv-checker-icon').src='chrome://abvchecker/content/throbber.gif';
		
		for (var i in childs){			
			var content = $.post(
				'http://m.abv.bg/servlet/mobilelogin',
				{
					password : prefs.getCharPref(childs[i]),
					username : childs[i],
					remember : 1
				},
				function (data){
					var re = new RegExp(/Кутия<\/a>.*?\n.*?\[(\d*)\]<br\/>/gm);
					var m = re.exec(data);
					var username = unescape(abvchecker.getQueryVariable(this.data,'username'));
					if (m == null || m.length == 0) {
						// alert(childs[i]+' '+0);
						document.getElementById(username+'_count_label').setAttribute('value',0);
						
					} else {
						// alert(childs[i]+' '+m[1]);
						document.getElementById(username+'_count_label').setAttribute('value',m[1]);
					}

				},
				'text'
			)
		}
		
		// document.getElementById('abv-checker-icon').src='chrome://abvchecker/content/throbber.gif';

		// abvchecktimer = setTimeout(abvchecker.checkForNewMail,abvchecker.prefs.getCharPref('update_interval')*1000*60);
		
	},
	getQueryVariable: function(query,variable) {
		// var query = window.location.search.substring(1);
		var vars = query.split("&");
		for (var i=0;i<vars.length;i++) {
			var pair = vars[i].split("=");
			if (pair[0] == variable) {
				return pair[1];
			}
		}
		// alert('Query Variable ' + variable + ' not found');
	} 

};
window.addEventListener("load", function(e) { abvchecker.onLoad(e); }, false);
